<?php
/*
    Plugin Name: AddFunc YouTube Players
    Plugin URI:
    Description: The shortcode that this plugin provides differs from the default WordPress [youtube] shortcode most notably in that it maintains the ratio you specify for the YouTube video. This allows for a responsive-friendly video player. Example shortcodes: [yt v=y0uTU83vd!D] [yt v=y0uTU83vd!D ratio=4:3] Accepts all YouTube Player parameters: https://developers.google.com/youtube/player_parameters Additionally, it includes default settings more suitable for the average video embedding case (such as turning OFF the showing of related videos at the end).
    Version: 0.6.4/3
    Author: Joe Rhoney
    Author URI: http://joerhoney.com/
           ______
       _  |  ___/   _ _ __   ____
     _| |_| |__| | | | '_ \ / __/™
    |_ Add|  _/| |_| | | | | (__
      |_| |_|   \__,_|_| |_|\___\
                    by Joe Rhoney
*/



/*
    C O N D I T I O N A L   J S   &   C S S
    =======================================
*/

$trigger_found = false;
add_filter('the_posts', 'aFyt_js_css_files');
function aFyt_js_css_files($posts){
  if (empty($posts)) return $posts;
  global $trigger_found;
  foreach ($posts as $post) {
    if (stripos($post->post_content, '[yt trigger') === false) { // For widget, add "&& empty(aFYTPOpts[trigger])" or something?
     $trigger_found = false;
    } else {
      $trigger_found = true;
      break;
    }
  }
  if ($trigger_found) {
    /*wp_enqueue_style('aFyt_stylesheet', plugins_url('responsiveslides.css', __FILE__));*/
    wp_enqueue_script( 'jquery' );
  }
  return $posts;
}
$ytjQselect = "";
$ytPlayerPause = "";



/*
    S H O R T C O D E S
    ===================
*/

# [yt v="YouTubeVideoID"] <- Displays a YouTube Video by ID
function aF_youtube( $atts ) {
  $ytMerged = shortcode_atts( array(
    'autohide'        => '1',
    'autoplay'        => '',
    'cc_load_policy'  => '',
    'color'           => '',
    'controls'        => '',
    'disablekb'       => '',
    'enablejsapi'     => '',
    'end'             => '',
    'fs'              => '',
    'iv_load_policy'  => '',
    'list'            => '',
    'listtype'        => '',
    'loop'            => '',
    'modestbranding'  => '',
    'origin'          => '',
    'playerapiid'     => '',
    'playlist'        => '',
    'playsinline'     => '',
    'rel'             => '0',
    'showinfo'        => '0',
    'start'           => '',
    'theme'           => '',
    'width'           => '640',
    'height'          => '480',
    'ratio'           => 'default',
    'x'               => '',
    'trigger'         => '',
    'v'               => 'NeedVideoID',
    'wmode'           => '',
    'allowfullscreen' => 'allowfullscreen'
  ), $atts, 'aF_youtube' );
  extract($ytMerged);
  foreach ($ytMerged as $ytKey => $ytVal) {
    if ((!empty($ytVal)||($ytVal == '0')) && ($ytKey != 'width') && ($ytKey != 'height') && ($ytKey != 'ratio') && ($ytKey != 'trigger') && ($ytKey != 'v') && ($ytKey != 'allowfullscreen')) {
      $ytStr[$ytKey] = $ytVal;
    }
  }
  $ytCount = 0;
  $ytParams = "";
  foreach ($ytStr as $ytParam => $ytSet) {
    if ($ytCount == 0) { $conx = "?"; }
    else { $conx = "&"; }
    $ytParams .= $conx.$ytParam."=".$ytSet;
    $ytCount++;
  }
  if ((strpos($ratio,':') == true)||(strpos($ratio,'-') == true)||(strpos($ratio,'x') == true)) {
    preg_match('/\d+/', $ratio, $fstnum);
    $fst = $fstnum[0];
    preg_match('/(\d+)\D*$/', $ratio, $sndnum);
    $snd = end($sndnum);
    $prc = ($snd/$fst) * 100;
    $ratio = $prc."%";
  } else {
    if(($ratio == 'default')||($ratio == '74')) {
      $ratio = "74%";
    } elseif (($ratio == 'half')||($ratio == '50')) {
      $ratio = "50%";
    } elseif (($ratio == 'standard')||($ratio == '75')) {
      $ratio = "75%";
    } elseif (($ratio == 'widescreen')||($ratio == 'hd')||($ratio == 'HD')||($ratio == '16x9')||($ratio == '16-9')||($ratio == '56')) {
      $ratio = "56.25%";
    } elseif (($ratio == '16x10')||($ratio == '16-10')||($ratio == '8x5')||($ratio == '8-5')||($ratio == '62')) {
      $ratio = "62.5%";
    } elseif (($ratio == '6x4')||($ratio == '6-4')||($ratio == '3x2')||($ratio == '3-2')||($ratio == '66')) {
      $ratio = "66.66%";
    } elseif (($ratio == '80')) {
      $ratio = "80%";
    } elseif (($ratio == 'square')||($ratio == '100')) {
      $ratio = "100%";
    } elseif (($ratio == 'portrait')||($ratio == '150')) {
      $ratio = "150%";
    } elseif (($ratio == '4x7')||($ratio == '4-7')||($ratio == '177')) {
      $ratio = "177.5%";
    }
  }
  $instance = "aFyt".uniqid();
  $hastrigger = "";
  if ($trigger) { $hastrigger = " hastrigger"; }
# $pseudobefore and $pseudoafter will eventually be an
# optional setting for backwards browser compatibility
# and OFF by default, but the default CSS may need to
# adjust depending on whether it is turned ON or OFF.
  $pseudobefore = "
  <div class=\"youTube\">";
  $pseudoafter = "
  </div>";
  $jsapi = "";
  if ($enablejsapi==1) { $jsapi = " jsapienabled"; }
  if ($x==1) { $x = "
  <div class=\"x\">X</div>"; }
  else { $x = ""; }
  $ytOutput = "
<div class=\"".$instance.$hastrigger.$jsapi." id-{$v}\">".$pseudobefore."
  <div class=\"yt-ratio\" style=\"padding-top:{$ratio};\">
    <iframe id=\"".$instance."\" width=\"{$width}\" height=\"{$height}\" src=\"https://www.youtube.com/embed/{$v}".$ytParams."\" frameborder=\"0\" {$allowfullscreen}></iframe>".$x."
  </div>".$pseudoafter."
</div>";
  global $ytjQselect, $ytPlayerPause;
  if ($ytMerged[trigger]) {
      $ytjQselect .= "
        $('".$trigger."').addClass('pauseYouTubes');
        $('".$trigger."').click(function() {
          $('.ytfocus').removeClass('ytfocus');
          $('.yttrigger').removeClass('yttrigger');
          $('body').addClass('ytblur');
          $(this).addClass('yttrigger');
          $('.x').addClass('showx');
          $('.overlay').addClass('showoverlay');
          $('.".$instance."').addClass('ytfocus');
        });";
      $ytPlayerPause .= "
          yt_players['".$instance."'].pauseVideo();";
          #bug0.6.3a: Format actually fails on multiple. Perhaps it should be: yt_players['ins1, ins2, ins3'].pauseVideo();
  }
  return $ytOutput;
}
add_shortcode( 'yt', 'aF_youtube' );



/*
    S T Y L E S
    ===========
*/

function aFyt_styles() { ?>
<style type="text/css" media="screen">
.youTube {
  display: inline-block;
  position: relative;
  width: 100%;
}
.youTube .yt-ratio iframe {
  width: 100%;
  height: 100%;
  overflow: hidden;
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
}
</style>
<?php }
add_action('wp_head','aFyt_styles');



/*
    W I D G E T
    ===========
*/

/*
class aFytbplyrswidget extends WP_Widget {
  protected static $did_script = false;
#   Register widget with WordPress
  function __construct()
  {
    parent::__construct(
      'aFytbplyrswidget', // Base ID
      'YouTube Player', // Name
      array('description'=> __('Display a YouTube video and control its settings.', 'text_domain' ),) // Args
    );
    if(!self::$did_script && is_active_widget(false, false, $this->id_base, true)){
      // add_action('wp_enqueue_scripts','aFytbplyrs_jscss');
      wp_enqueue_script('jquery'); // ???
      self::$did_script = true;
    }
  }
#   Front-end display of widget
  public function widget($args,$instance)
  {
    extract($instance);
      $aFytbplyrs_inst = 'aFyt'.uniqid();
      $title = apply_filters('widget_title',$instance['title']);
      echo $args['before_widget'];




    global $aFytbplyrsinit;
    $aFytbplyrsinit = true;
  }
#   Back-end widget form
public function form($instance)
  {
    extract($instance);
    // Storing IDs = less queries
    $titleGfid =            $this->get_field_id('title');

    $sldstGfid =            $this->get_field_id('slideset');

    $behaviorOptsGfid =     $this->get_field_id('behaviorOpts');
    $autoGfid =             $this->get_field_id('auto');
    $speedGfid =            $this->get_field_id('speed');
    $navContainerTextGfid = $this->get_field_id('navContainer');
    $beforeGfid =           $this->get_field_id('before');
    ?>
    <p><label for="<?php echo $titleGfid; ?>"><?php _e('Title:'); ?></label>
    <input class="widefat" id="<?php echo $titleGfid; ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" />
    </p>
<?php
    $sldsts = get_terms('slidesets');
    if (!empty($sldsts) && !is_wp_error($sldsts)){ ?>
    <p><label for="<?php echo $sldstGfid; ?>">Slideset: </label>
    <select id="<?php echo $sldstGfid; ?>" name="<?php echo $this->get_field_name('slideset'); ?>">
<?php   foreach ($sldsts as $sldst){
          if($sldst->term_id==esc_attr($slideset))
          {
            $selected = ' selected="selected"';
          } else {
            $selected = '';
          }?>
        <option value="<?php echo $sldst->term_id; ?>"<?php echo $selected; ?>><?php echo $sldst->name; ?></option>
<?php  } ?>
      </select>
      <?php
    } ?></p>

  <input class="aFexpand" type="checkbox" style="display:none;" name="<?php echo $this->get_field_name('behaviorOpts'); ?>" id="<?php echo $behaviorOptsGfid; ?>" value="1" <?php checked( '1', $instance['behaviorOpts'] ); ?> />
  <fieldset class="aFexpand">
    <label for="<?php echo $behaviorOptsGfid; ?>"><h4>Behavior Options</h4></label>
    <div>
      <input class="aFswitch" type="checkbox" name="<?php echo $this->get_field_name('auto'); ?>" id="<?php echo $autoGfid; ?>" value="false" <?php checked( 'false', $instance['auto'] ); ?> />
      <label class="aFswitch" for="<?php echo $autoGfid; ?>" title='Boolean: Animate automatically. Default: true'>Autoplay <span><b>OFF</b><b style="display:none;">ON</b></span></label>
    </div>
    <div>
      <label class="aFtext" for="<?php echo $speedGfid; ?>" title='Integer: Speed of the transition, in milliseconds. Default: 500'>Speed: </label><input id="<?php echo $speedGfid; ?>" class="aFtext small-text" type="text" name="<?php echo $this->get_field_name('speed'); ?>" value="<?php echo esc_attr($speed); ?>" />
    </div>
    <div>
      <label class="aFtext" for="<?php echo $navContainerGfid; ?>" title='Selector: Where controls should be appended to. Default: (immediately after the slides)'>Nav Container: </label><input id="<?php echo $navContainerGfid; ?>" class="widefat" type="text" name="<?php echo $this->get_field_name('navContainer'); ?>" value="<?php echo esc_attr($navContainer); ?>" /><br /><span class="description"></span>
    </div>
    <div>
      <label class="aFtext" for="<?php echo $beforeGfid; ?>" title='Function: Before callback. Default: (null)'>Before: </label><textarea id="<?php echo $beforeGfid; ?>" class="large-text" name="<?php echo $this->get_field_name('before'); ?>"><?php echo esc_attr($before); ?></textarea>
    </div>
  </fieldset>

<?php }
#   Sanitize widget form values as they are saved
  public function update( $new_instance, $old_instance )
  {
    $instance = array();
    $instance['title'] = (!empty($new_instance['title']))
      ? strip_tags( $new_instance['title']) : '';

    $instance['slideset'] = (!empty($new_instance['slideset']))
      ? strip_tags( $new_instance['slideset']) : '';

    $instance['behaviorOpts'] = (!empty($new_instance['behaviorOpts']))
      ? strip_tags( $new_instance['behaviorOpts']) : '';
    $instance['auto'] = (!empty($new_instance['auto']))
      ? strip_tags( $new_instance['auto']) : '';
    $instance['speed'] = (!empty($new_instance['speed']))
      ? strip_tags( $new_instance['speed']) : '';
    $instance['navContainer'] = (!empty($new_instance['navContainer']))
      ? strip_tags( $new_instance['navContainer']) : '';
    $instance['before'] = (!empty($new_instance['before']))
      ? strip_tags( $new_instance['before']) : '';

    return $instance;
  }
} // class
#   register widget
function reg_aFytbplyrswidget() {
    register_widget('aFytbplyrswidget');
}
add_action('widgets_init','reg_aFytbplyrswidget');
*/



/*
    J S   I N I T I A L I Z A T I O N
    =================================
    Thanks to this example: http://jsfiddle.net/av359/
*/

function aFyt_init() {
  global $trigger_found, $ytjQselect, $ytPlayerPause;
  if ($trigger_found) { ?>
  <script>
    jQuery(function($) {
      $(document).ready(function() {
        var yt_int, yt_players={},
          initYT = function() {
            $(".jsapienabled iframe").each(function() {
              yt_players[this.id] = new YT.Player(this.id);
            });
          };
        $.getScript("https://www.youtube.com/player_api", function() {
          yt_int = setInterval(function(){
            if(typeof YT === "object"){
              initYT();
              clearInterval(yt_int);
            }
          },0);
        });
        <?php echo $ytjQselect."\n"; ?>
        $('.pauseYouTubes').click(function() {<?php
          echo $ytPlayerPause."\n"; ?>
        });
        $('.x, .overlay').click(function() {
          $('.ytfocus').removeClass('ytfocus');
          $('.overlay').removeClass('showoverlay');
          $('.x').removeClass('showx');
          $('.yttrigger').removeClass('yttrigger');
          $('.ytblur').removeClass('ytblur');<?php
          echo $ytPlayerPause."\n"; ?>
        });
      });
    });
  </script>
  <?php
  }
}
add_action('wp_footer', 'aFyt_init');



/*
    S E T T I N G S   P A G E
    =========================
*/

# Remove default value before saving to the database
if(!class_exists('AverageYouTubePlayers')) :
// DEFINE PLUGIN ID
define('aFytbplyrs_ID', 'aFytbplyrs');
// DEFINE PLUGIN NICK
define('aFytbplyrs_NICK', 'YouTube');
  class AverageYouTubePlayers
  {
    # function/method
    # Usage: return absolute file path
    # Arg(1): string
    # Return: string
    public static function file_path($file)
    {
      return ABSPATH.'wp-content/plugins/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).$file;
    }
    # function/method
    # Usage: hooking the plugin options/settings
    # Arg(0): null
    # Return: void
    public static function register()
    {
      register_setting(aFytbplyrs_ID.'_options', 'default_youtube_showinfo');
      register_setting(aFytbplyrs_ID.'_options', 'default_youtube_rel');
      /*register_setting(aFytbplyrs_ID.'_options', 'cookie_expiration','xdefaultvalue');*/
    }
    # function/method
    # Usage: hooking (registering) the plugin menu
    # Arg(0): null
    # Return: void
    public static function menu()
    {
      // Create menu tab
      add_options_page(aFytbplyrs_NICK.' Plugin Options', aFytbplyrs_NICK, 'manage_options', aFytbplyrs_ID.'_options', array('AverageYouTubePlayers', 'options_page'));
    }
    # function/method
    # Usage: show options/settings form page
    # Arg(0): null
    # Return: void
    public static function options_page()
    {
      if (!current_user_can('manage_options'))
      {
        wp_die(__('You do not have sufficient permissions to access this page.'));
      }
      $plugin_id = aFytbplyrs_ID;
      // display options page
      include(self::file_path('options.php'));
    }
  }
  if (is_admin())
  {
    add_action('admin_init', array('AverageYouTubePlayers','register'));
    add_action('admin_menu', array('AverageYouTubePlayers','menu'));
  }
endif;